#define __ASSEMBLY__

#include <alpha/jmp_buf.h>
#include <alpha/regdef.h>

#include <asm/pal.h>

/*
 * Jump to the position specified by ENV, causing the
 * setjmp call there to return VAL, or 1 if VAL is 0. 
 * Usage:
 *	void __longjmp(jmp_buf *buf, int val)
 */

	.data
error_msg:
	.asciz "__longjmp: bad magic number"

	.text

	.weakext longjmp, __longjmp

	.globl	__longjmp
	.ent	__longjmp
__longjmp:
	.frame	sp,0,ra,0
	/*
	 * Re-establish registers.  V0 gets set with whatever
	 * we specify, unless we specify zero.	In order to
	 * avoid ambiguity, we must always return nonzero to
	 * the caller of sigjmp...
	 *
	 * We load up t0 with the return PC.  sigjmp restores t0
	 * properly.
	 *
	 * Save a0 for last, for obvious reasons!
	 */
	.prologue 1

	/*
	 * Sanity check:
	 */
	bis	a1,zero,v0
	lda	t0,(JBMAGIC & 0xffff)(zero)
	ldah	t0,(JBMAGIC >> 16)(t0)
	cmoveq	v0,1,v0			/* ensure v0 != 0 */

	ldq	t1,JB_MAGIC*8(a0)
	subq	t0,t1, t0
	ldq	sp,JB_SP*8(a0)
	bne	t0,bad_magic

	ldq	t0,JB_PC*8(a0)
	ldq	t1,JB_T1*8(a0)
	ldq	t2,JB_T2*8(a0)
	ldq	t3,JB_T3*8(a0)
	ldq	t4,JB_T4*8(a0)
	ldq	t5,JB_T5*8(a0)
	ldq	t6,JB_T6*8(a0)
	ldq	t7,JB_T7*8(a0)
	ldq	s0,JB_S0*8(a0)
	ldq	s1,JB_S1*8(a0)
	ldq	s2,JB_S2*8(a0)
	ldq	s3,JB_S3*8(a0)
	ldq	s4,JB_S4*8(a0)
	ldq	s5,JB_S5*8(a0)
	ldq	fp,JB_S6*8(a0)
	ldq	a1,JB_A1*8(a0)
	ldq	a2,JB_A2*8(a0)
	ldq	a3,JB_A3*8(a0)
	ldq	a4,JB_A4*8(a0)
	ldq	a5,JB_A5*8(a0)
	ldq	t8,JB_T8*8(a0)
	ldq	t9,JB_T9*8(a0)
	ldq	t10,JB_T10*8(a0)
	ldq	t11,JB_T11*8(a0)
	ldq	ra,JB_RA*8(a0)
	ldq	pv,JB_PV*8(a0)
	ldq	AT,JB_AT*8(a0)
	ldq	gp,JB_GP*8(a0)
	ldq	sp,JB_SP*8(a0)
	ldt	$f0,JB_F0*8(a0)
	ldt	$f1,JB_F1*8(a0)
	ldt	$f2,JB_F2*8(a0)
	ldt	$f3,JB_F3*8(a0)
	ldt	$f4,JB_F4*8(a0)
	ldt	$f5,JB_F5*8(a0)
	ldt	$f6,JB_F6*8(a0)
	ldt	$f7,JB_F7*8(a0)
	ldt	$f8,JB_F8*8(a0)
	ldt	$f9,JB_F9*8(a0)
	ldt	$f10,JB_F10*8(a0)
	ldt	$f11,JB_F11*8(a0)
	ldt	$f12,JB_F12*8(a0)
	ldt	$f13,JB_F13*8(a0)
	ldt	$f14,JB_F14*8(a0)
	ldt	$f15,JB_F15*8(a0)
	ldt	$f16,JB_F16*8(a0)
	ldt	$f17,JB_F17*8(a0)
	ldt	$f18,JB_F18*8(a0)
	ldt	$f19,JB_F19*8(a0)
	ldt	$f20,JB_F20*8(a0)
	ldt	$f21,JB_F21*8(a0)
	ldt	$f22,JB_F22*8(a0)
	ldt	$f23,JB_F23*8(a0)
	ldt	$f24,JB_F24*8(a0)
	ldt	$f25,JB_F25*8(a0)
	ldt	$f26,JB_F26*8(a0)
	ldt	$f27,JB_F27*8(a0)
	ldt	$f28,JB_F28*8(a0)
	ldt	$f29,JB_F29*8(a0)
	ldt	$f30,JB_F30*8(a0)
	ldq	a0,JB_A0*8(a0)

	/* Now go back as though from a bad dream... */
	jmp	zero,(t0)

bad_magic:
	br	gp,1f
1:	ldgp	gp,0(gp)
	lda	a0,_IO_stderr_
	lda	a1,error_msg
	lda	pv,fprintf
	jsr	ra,(pv)

	lda	pv,abort
	jsr	ra,(pv)
	
	.end	__longjmp
