#include <dirent.h>
#include <errno.h>
#include <syscall.h>
#include <dirent.h>
#include <gnu-stabs.h>

/*
 * readdir fills up the buffer with the readdir system call. it also
 * gives a third parameter (currently ignored, but should be 1) that
 * can with a future kernel be enhanced to be the number of entries
 * to be gotten.
 *
 */

struct dirent *
__readdir(DIR * dir)
{
	int result;
	int len;
	struct dirent *res;

	if (!dir) {
		errno = EBADF;
		return NULL;
	}
	if (dir->dd_size <= dir->dd_loc) {
		/*
		 * Read count of directory entries.  For now it should
		 * be one.
		 */
		result = __syscall(SYS_getdents, dir->dd_fd, dir->dd_buf,
				   sizeof(struct dirent) * NUMENT);
		if (result <= 0) {
			if (result < 0) {
				errno = -result;
			}
			return NULL;
		}
		dir->dd_size = (result + 7) / 8;
		dir->dd_loc = 0;
	}
	res = (struct dirent *)(dir->dd_buf + dir->dd_loc);
	len = (res->d_reclen + 7) / 8;
	dir->dd_loc += len;
	dir->dd_off = res->d_off;
	res->d_ino &= 0xffffffff;
	return res;
}

weak_alias(__readdir, readdir);
