/* Copyright (C) 1992 Free Software Foundation, Inc.
This file is part of the GNU C Library.

The GNU C Library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public License as
published by the Free Software Foundation; either version 2 of the
License, or (at your option) any later version.

The GNU C Library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with the GNU C Library; see the file COPYING.LIB.  If
not, write to the Free Software Foundation, Inc., 675 Mass Ave,
Cambridge, MA 02139, USA.  */

/* This has to be here so we can override the default definition in
   sysdeps/linux/sysdep.h */

#define RETSYS(name)	ret zero,(ra);\
	.end name##;

#include <sysdeps/linux/sysdep.h>
#include <alpha/regdef.h>
#include <asm/pal.h>

#ifndef LINUX_ALPHA_SYSDEP_H
#define LINUX_ALPHA_SYSDEP_H

#define ENTRY(name)                                                           \
  .globl _##name##;							      \
  .align 3;								      \
  .ent _##name##;							      \
  _##name##:

/* Linux/AXP expects system calls from user mode to pass args as follows:
 *
 *	a0-a5 [$16-$21] - first six integer args
 *	v0 [$0] - System call number
 *
 * Outputs are returned as follows:
 *	a3 - Set if error, cleared otherwise.
 *	v0 - System call return value.
 */

/*
 * Note:  I took out the ## surrounding the 'name' parameter in the macro
 * below.  Apparently the GNU compiler treats them as the concatenation
 * operator and it was wreaking havoc.  bjn, 8/25/94.
 */

#define PSEUDO(name, syscall_name, args)                \
    .text;						\
    .align 3;						\
    .ent name;						\
.globl	name;						\
name:							\
    .frame	sp,0,ra,0;				\
    .prologue	1;					\
    lda		v0,SYS_##syscall_name(zero);		\
    call_pal	PAL_callsys;				\
    beq		a3,1f;					\
    br		gp,2f;					\
2:  ldgp	gp,0(gp);				\
    stl		v0,errno;				\
    lda		v0,-1(zero);				\
1:

#define RETURN  ret zero,(ra)
/* Linux doesn't use it. */

#define r0	a4
#define r1	v0
#define MOVE(x,y)       bis x , x, y


#endif /* ALPHA_LINUX_SYSDEP_H */
